//+------------------------------------------------------------------+
//|                                                    Pattern_1.mq4 |
//|                                                   Semenov Alexey |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Semenov Alexey"
#property link      ""

extern double  Lots             = 0.1;
extern string omment           = "Pattern_1";
extern int StopLoss             = 150;   
extern int TakeProfit           = 150;     
extern int    TrailingStop      = 2040;    
extern int Slippage             = 2; //  
extern int BULevel              = 1890;
extern int   NotBULevel         = 100;         //    
extern int Magic                = 124124;

extern string  Potenza              = "Potenza"; 
extern string note_1 = "1-RSI; 2-WPR; 3-Stoch; 4-BB%B; 5-MACD";
extern int algo = 2;
extern bool use_default_periods = TRUE;
extern string my_period = "20";
int G_str2int_224;
int G_str2int_228 = 12;
int G_str2int_232 = 26;
int G_period_236 = 9;
extern int smoothing = 1;
extern bool show_all = FALSE;
extern bool show_aud = TRUE;
extern bool show_cad = TRUE;
extern bool show_chf = TRUE;
extern bool show_eur = TRUE;
extern bool show_gbp = TRUE;
extern bool show_jpy = TRUE;
extern bool show_nzd = TRUE;
extern bool show_usd = TRUE;
extern bool show_labels = TRUE;
extern color aud_color = Red;
extern color cad_color = Yellow;
extern color chf_color = White;
extern color eur_color = Lime;
extern color gbp_color = DarkOrange;
extern color jpy_color = DodgerBlue;
extern color nzd_color = Magenta;
extern color usd_color = Aqua;
extern bool show_entry_signals = TRUE;
extern int bars_for_signals = 100;
extern bool show_correlations = FALSE;
extern bool automatic_line_weigth = TRUE;
extern bool force_update = TRUE;
extern int text_size = 10;
extern string text_font = "Segoe UI";
//note_1,algo,use_default_periods,my_period,smoothing,show_all,show_aud,show_cad,show_chf,show_eur,show_gbp,show_jpy,show_nzd,show_usd,show_labels,aud_color,
//cad_color,chf_color,eur_color,gbp_color,jpy_color,nzd_color,usd_color,show_entry_signals,bars_for_signals,show_correlations,automatic_line_weigth,force_update,
//text_size,text_font,

int total, Ticket;
string Text;
bool answer;
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
   int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;

   if (OrdersTotal()>0)
   {  for (int i=OrdersTotal()-1; i>=0; i--)
      {  if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {  if (OrderSymbol()!=Symbol())   continue;
            if (OrderMagicNumber()!=Magic) continue;
            {  if(OrderType()==OP_BUY)  buys++;
               if(OrderType()==OP_SELL) sells++;
            }
   }  }  }

   if(buys>0) return(buys);
   else       return(-sells);
   }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
{
   int ticket, STOPLEVEL;
   double Price, SL, TP; 
   STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
   
  double VE_1 = iCustom (0,PERIOD_H1,"PotenzaFX Powerlines",note_1,algo,use_default_periods,my_period,smoothing,show_all,show_aud,show_cad,show_chf,show_eur,show_gbp,show_jpy,show_nzd,show_usd,show_labels,aud_color,
cad_color,chf_color,eur_color,gbp_color,jpy_color,nzd_color,usd_color,show_entry_signals,bars_for_signals,show_correlations,automatic_line_weigth,force_update,
text_size,text_font,3,1); // 
  double VE_2 = iCustom (0,PERIOD_H1,"PotenzaFX Powerlines",note_1,algo,use_default_periods,my_period,smoothing,show_all,show_aud,show_cad,show_chf,show_eur,show_gbp,show_jpy,show_nzd,show_usd,show_labels,aud_color,
cad_color,chf_color,eur_color,gbp_color,jpy_color,nzd_color,usd_color,show_entry_signals,bars_for_signals,show_correlations,automatic_line_weigth,force_update,
text_size,text_font,3,2);
  double MO_1 = iCustom (0,PERIOD_H1,"PotenzaFX Powerlines",note_1,algo,use_default_periods,my_period,smoothing,show_all,show_aud,show_cad,show_chf,show_eur,show_gbp,show_jpy,show_nzd,show_usd,show_labels,aud_color,
cad_color,chf_color,eur_color,gbp_color,jpy_color,nzd_color,usd_color,show_entry_signals,bars_for_signals,show_correlations,automatic_line_weigth,force_update,
text_size,text_font,4,1); // 
  double MO_2 = iCustom (0,PERIOD_H1,"PotenzaFX Powerlines",note_1,algo,use_default_periods,my_period,smoothing,show_all,show_aud,show_cad,show_chf,show_eur,show_gbp,show_jpy,show_nzd,show_usd,show_labels,aud_color,
cad_color,chf_color,eur_color,gbp_color,jpy_color,nzd_color,usd_color,show_entry_signals,bars_for_signals,show_correlations,automatic_line_weigth,force_update,
text_size,text_font,4,2);
   

   
   if(Volume[0]>1) return;

    // 
   if (VE_2 > VE_1 && MO_2 < MO_1 && VE_2 > MO_2 && VE_1 < MO_1 && Open[1] > Close[1])
 {
     Price = NormalizeDouble(Bid, Digits); //        
     if(StopLoss >= STOPLEVEL)
          if(StopLoss > 0)
      {
       SL = Price + StopLoss*Point; //  
       SL = NormalizeDouble(SL, Digits); //        
      }
       else SL = 0;

      if(TakeProfit > 0)
      {
       TP = Price - TakeProfit*Point;
       TP = NormalizeDouble(TP, Digits); 
      }
       else TP = 0;
    {
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,omment,Magic,0,Red); // Alert ("Sell", Symbol())
    }
  }         
   // 
   if (VE_2 < VE_1 && MO_2 > MO_1 && VE_2 < MO_2 && VE_1 > MO_1 && Open[1]<Close[1])
  {
     Price = NormalizeDouble(Bid, Digits); //        
     if(StopLoss >= STOPLEVEL)
          if(StopLoss > 0)
      {
       SL = Price - StopLoss*Point; //  
       SL = NormalizeDouble(SL, Digits); //        
      }
       else SL = 0;

      if(TakeProfit > 0)
      {
       TP = Price + TakeProfit*Point;
       TP = NormalizeDouble(TP, Digits); 
      }
       else TP = 0;
    {
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,omment,Magic,0,Blue);
    }   
   }
}

//+------------------------------------------------------------------+
//                                                           |
//+------------------------------------------------------------------+
int Trailing()
 {
   for(int i = 0; i < OrdersTotal(); i ++) //  
      {
    if(OrderSelect(i, SELECT_BY_POS) == false) continue; //    ,    
    if(Magic != OrderMagicNumber()) continue;//        Magic -    
    Ticket = OrderTicket(); //   
    if((OrderType() == 1) && (OrderOpenPrice() - Ask > TrailingStop*Point) && ((OrderStopLoss() > Ask + TrailingStop*Point) || (OrderStopLoss()==0)))
     {
      if(OrderStopLoss() == NormalizeDouble(Ask + TrailingStop*Point,Digits)) return(0); //     1
      Text ="Sell"; //   inf...         .
      
      answer = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask + TrailingStop*Point,Digits),OrderTakeProfit(),0,Red);
      if(answer == true) //  true    
       { //   

        return(1); //   start()
       }

      return(0); //   start()
     }
    if((OrderType() == 0) && (Bid - OrderOpenPrice() > TrailingStop*Point) && (OrderStopLoss() < Bid - TrailingStop*Point))
     {
      if(OrderStopLoss() == NormalizeDouble(Bid - TrailingStop*Point,Digits)) return(0); //     1
      Text ="Buy"; //   inf...         .

      answer = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid - TrailingStop*Point,Digits),OrderTakeProfit(),0,Blue);
      if(answer == true) //  true    
       { //   

        return(1); //   start()
       }

      return(0); //   start()
     }
   } //  
  return(0);
 }
 
 //+------------------------------------------------------------------+            

void BU()
{
   for(int a=0; a<OrdersTotal(); a++) 
  {
       if (OrderSelect(a, SELECT_BY_POS)) 
        {      
         if(OrderMagicNumber()!=Magic  || OrderSymbol()!=Symbol()) continue;
         if(OrderType()==OP_BUY) 
          {
           if(OrderOpenPrice()<=(Bid-BULevel*Point-NotBULevel*Point)&& OrderOpenPrice()>OrderStopLoss())//    + 20 
            {      
             OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+NotBULevel*Point,OrderTakeProfit(),0,Green);
            }
           }       
 
         if(OrderType() == OP_SELL) 
           {
            if(OrderOpenPrice()>=(Ask+BULevel*Point+NotBULevel*Point)&& (OrderOpenPrice()<OrderStopLoss() || OrderStopLoss() == 0 ))//    + 20 
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-NotBULevel*Point,OrderTakeProfit(),0,Red);
             }
           } 
         }
       }
 return(0);
 }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()

   {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();

 Trailing(); //   
  if (BULevel!=0) BU();
  }

